<?php if (!defined('PmWiki')) exit();
/*  Copyright 2004 Patrick R. Michaud (pmichaud@pobox.com).

    This file adds a "dictindex" (dictionary index) format for
    the (:pagelist:) and (:searchresults:) directives.  To see results
    in dictionary format, simply add fmt=dictindex to the directive, as in

        (:pagelist group=Main fmt=dictindex:)

    By default the items are display as a simple definition list, but
    this can be controlled by $FPLDictIndex...Fmt variables:

        $FPLDictIndexStartFmt   - start string
        $FPLDictIndexEndFmt     - end string
        $FPLDictIndexLFmt       - string to output for each new letter
        $FPLDictIndexIFmt       - string to output for each item in list
        $FPLDictIndexHeaderLink - string for the link list at the upper page

    To enable this module, simply add the following to config.php:

        include_once('cookbook/titledictindex.php');

    Christian added teaser text to Karl's titled version.
    John added publish capability.

*/

$FPLFunctions['dictindex'] = 'FPLDictIndex';

function FPLDictIndex($pagename,&$matches,$opt) {
  global $FPLDictIndexStartFmt,$FPLDictIndexEndFmt,$FPLDictIndexLFmt,
    $FPLDictIndexIFmt, $FPLDictIndexHeaderLink, $FmtV, $FPLDictTeaserAnchor,
    $PublishSearch, $PublishSearchChecked, $PDFCheckboxFmt, $PDFTypesetFmt, 
    $PDFOptionsFmt, $HTMLVSpace, $format, $FPLDictIndexLIFmt,$SearchPatterns;
  $SearchPatterns['normal'][] = "!$pagename!";
  $opt['order']='title';
  $matches = MakePageList($pagename, $opt);
  for($n=0;$n<count($matches);$n++)
    $matches[$n]['name'] = FmtPageName('$Title',$matches[$n]['pagename']);
  $cmp = create_function('$x,$y',
    "return strcasecmp(\$x['name'],\$y['name']);");
  usort($matches,$cmp);
  if ($PublishSearch) {
      $checked = ($PublishSearchChecked) ? "checked='checked'" : '';
      $FPLDictIndexStartFmt = "<a name='dictindexheader'></a>
    <form class='publish' action='\$ScriptUrl' method='get'>
    <input type='hidden' name='n' value='\$FullName' /><dl class='fpldictindex'><span>\$IndexLinks</span>$HTMLVSpace";
      $FPLDictIndexEndFmt = "</dl>$HTMLVSpace
    <input type='hidden' name='action' value='publish' />
    <input type='hidden' name='ptype' value='search' />
    <input type='hidden' name='page' value='\$FullName' />
    $PDFCheckboxFmt$PDFTypesetFmt$PDFOptionsFmt</form>";
      $FPLDictIndexIFmt = 
    "<dd><input class='dictcheckbox' type='checkbox' name='pagearray[]' value='\$Group/\$Name' $checked/>
     <a href='\$PageUrl'>\$Title</a>: \$Teaser</dd>";
  }

  SDV($FPLDictIndexStartFmt,"<a name='dictindexheader'></a><dl class='fpldictindex'><span>\$IndexLinks</span><hr>$HTMLVSpace");
  SDV($FPLDictIndexEndFmt,'</dl>');
  SDV($FPLDictIndexLFmt,"<dt><a href='#dictindexheader'>&#9650;</a> <a name='\$IndexLetter'></a>\$IndexLetter</dt>\n");
  SDV($FPLDictIndexIFmt,"<dd><a href='\$PageUrl'>\$Title</a>: \$Teaser</dd>");
  SDV($FPLDictIndexHeaderLink,'<a href="#$IndexLetter">$IndexLetter</a>');
  SDV($FPLDictTeaserAnchor,'teaser');

  $out = array();
  $headerlinks= array();
  foreach($matches as $item) {
    $pletter = substr($item['name'],0,1);
    $FmtV['$IndexLetter'] = $pletter;
    if ($pletter!=@$lletter) { 
      $out[] = FmtPageName($FPLDictIndexLFmt,$item['pagename']);
      $headerlinks[] = FmtPageName($FPLDictIndexHeaderLink,$item['pagename']);
      $lletter = $pletter;
      if ($format=='pdf') $FPLDictIndexLFmt = $FPLDictIndexLIFmt;
    }
    $FmtV['$Teaser'] = MarkupToHtml($item['pagename'],
	TeaseParagraph($pagename, $item['pagename'], $FPLDictTeaserAnchor));
    if ($format=='pdf') $FmtV['$Teaser'] = 
        preg_replace('/(<\\/?)/', "$1".'tbook:', $FmtV['$Teaser']);
    
    $out[] = FmtPageName($FPLDictIndexIFmt,$item['pagename']);
  }
  $FmtV['$IndexLinks']=implode(' &#9679; ',$headerlinks);

  return FmtPageName($FPLDictIndexStartFmt,$pagename).implode('',$out).
    FmtPageName($FPLDictIndexEndFmt,$pagename);
}

?>
